#ifndef __ROCIO_SLU__
#define __ROCIO_SLU__

#include <vector>
#include <fst/fstlib.h>

extern "C" {

typedef struct {
    int lexidword;
    int lexidaction;
    fst::StdVectorFst* fstModel;
    fst::StdVectorFst* fstClean;
    std::vector<char*>* actions;
    std::vector<char*>* words;
} slu_t;

slu_t* init_slu(char* chfileword, char* chfileaction, char* chfilemodel, char* chfileclean);

int run_slu(slu_t* slu, char** words, int num_words, int prevn, char *prevword);

int num_actions(slu_t* slu);

char* get_action(slu_t* slu, size_t index);

void free_slu(slu_t* slu);

void ERREUR(const char *ch1, const char *ch2);
}

#endif
